## --------------------------------------------------------
# crear un obxecto datos, usando mtcars, colección de datos de coches incluida en R básico
datos=mtcars
nomes=names(datos)# gardar nun vector os nomes das variables de datos
# garda os obxectos nomes e datos nun ficheiro, con formato Rdata, formato propio de R
save(nomes,datos,file="proba.Rdata")
#borro eses obxectos da memoria, pàra ver despois como se fai a recuperación
rm(nomes, datos)


## --------------------------------------------------------
# carga en memoria os obxectos que se gardaron en "proba.Rdata"
load("proba.Rdata")


## --------------------------------------------------------
# Pódese facer coa escoba do Environment, pero tamén con este código:
rm(list=ls())


## --------------------------------------------------------
# cargar o paquete
library(dplyr)


## --------------------------------------------------------
datos=mtcars


## --------------------------------------------------------
# coller datos e entón seleccionar as variables mpg,cyl,hp,wt,am, finalmente gardar en datos2
datos %>% select(mpg,cyl,hp,wt,am)->datos2


## --------------------------------------------------------
names(datos)[4:7]
datos %>% select(-qsec)->borrar # elimina qsec e garda en borrar
datos %>% select(-c(qsec,gear))-> borrar # elimina qsec e gear e garda en borrar


## --------------------------------------------------------
datos %>% select(mpg,cyl,am) %>% filter(cyl==8) # colle soamente os coches con cyl igual a 8
# o simbolo == indica comparación a==b pregúntase se a e b son iguais, e respondera FALSE

# filtrar con dúas condicións cyl igual a 8 e am igual a 1
datos %>% select(mpg,cyl,am) %>% filter(cyl==8,am==1)

# filtrar con algunha de dúas condicións ou cyl igual a 8, ou am igual a 1
datos %>% select(mpg,cyl,am) %>% filter(cyl==8|am==1)

# Poñer ! diante dunha expresión loxica implica negar: filtrar con algunha de dúas condicións ou cyl distinto de 8, ou am igual a 1

datos %>% select(mpg,cyl,am) %>% filter(!cyl==8|am==1)
# O mesmo de antes
datos %>% select(mpg,cyl,am) %>% filter(cyl!=8|am==1)
# agora a negación afecta a toda a expresión: filtrar o que non cumpre cyl igual a 8, ou am igual a 1
datos %>% select(mpg,cyl,am) %>%
  filter(!(cyl==8|am==1))



## --------------------------------------------------------
# datos%>%mutate(variablenova1=variablevella1+2*variablevella2,variablenova2=log(variablevella1)^2)->datos 
datos%>%mutate(pesoenkg=wt*0.453592,kmxlitro=mpg*0,42514)->datos 
#creouse novas variables, coas unidades en sistema métrico decimal: pasa librar a kilos e millas por galon a km por litro


## --------------------------------------------------------
#facer varios calculos para unha variable con un comando, separando os resultados polos niveis dun atributo
# datos %>% group_by(atributo)%>%
#   summarise(N = n(), media = mean(variable), maximo = max(variable), cuartil1 = quantile(variable,0.25,na.rm = TRUE),desviacion_tipica=sd(variable,na.rm = TRUE))

#consumo medio dos coches segundo o seu numero de cilindros
datos %>% group_by(cyl)%>%summarise(media = mean(mpg))

# contar nº de coches de cada cantidade de cilindros, o seu consumo medio e a desviación típica do seu peso
datos %>% group_by(cyl)%>% summarise(N = n(), media = mean(mpg), dtpeso = sd(wt))

# agora agrupando por cilindros e por automatico ou non (am)
datos %>% group_by(cyl,am)%>% summarise(N = n(), media = mean(mpg), dtpeso = sd(wt))

